"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var t = __importStar(require("@babel/types"));
var ast_builders_1 = require("../utils/ast-builders");
var css_builders_1 = require("../utils/css-builders");
var extractStyledDataFromNode = function (node) {
    if (t.isTaggedTemplateExpression(node) &&
        t.isMemberExpression(node.tag) &&
        t.isIdentifier(node.tag.object) &&
        node.tag.object.name === 'styled' &&
        t.isIdentifier(node.tag.property)) {
        var tagName = node.tag.property.name;
        var cssNode = node.quasi;
        return {
            tagName: tagName,
            cssNode: cssNode,
        };
    }
    if (t.isCallExpression(node) &&
        t.isMemberExpression(node.callee) &&
        t.isIdentifier(node.callee.object) &&
        node.callee.object.name === 'styled' &&
        t.isObjectExpression(node.arguments[0]) &&
        t.isIdentifier(node.callee.property)) {
        var tagName = node.callee.property.name;
        var cssNode = node.arguments[0];
        return {
            tagName: tagName,
            cssNode: cssNode,
        };
    }
    return undefined;
};
exports.visitStyledPath = function (path, state) {
    var styledData = extractStyledDataFromNode(path.node);
    if (!styledData) {
        return;
    }
    var cssOutput = css_builders_1.buildCss(styledData.cssNode, state);
    path.replaceWith(ast_builders_1.buildStyledComponent({
        cssOutput: cssOutput,
        tagName: styledData.tagName,
        parentPath: path,
        scope: path.scope,
    }));
};
//# sourceMappingURL=index.js.map