import * as t from '@babel/types';
import { Scope, NodePath } from '@babel/traverse';
import { CSSOutput } from './css-builders';
import { PluginOptions } from '../types';
interface BaseOpts extends PluginOptions {
    cssOutput: CSSOutput;
}
interface StyledOpts extends BaseOpts {
    tagName: string;
    parentPath: NodePath;
    scope: Scope;
}
interface CompiledOpts extends BaseOpts {
    node: t.JSXElement;
}
export declare const joinExpressions: (left: any, right: any, spacer?: any) => t.BinaryExpression;
export declare const conditionallyJoinExpressions: (left: any, right: any) => t.BinaryExpression;
export declare const buildStyledComponent: (opts: StyledOpts) => t.Node;
export declare const importSpecifier: (name: string, localName?: string | undefined) => t.ImportSpecifier;
export declare const buildCompiledComponent: (opts: CompiledOpts) => t.Node;
export {};
